Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## unity.jdbc
Class UnityConnection

    java.lang.Object
      unity.jdbc.UnityConnection

All Implemented Interfaces:
  java.sql.Connection

    public class UnityConnection

extends java.lang.Object
implements java.sql.Connection

A connection (session) with the integrated database. Queries that span multiple databases can be processed, divided into SQL on the individual JDBC sources, and then combined on the client.

A `Connection` object provides information on the tables in all databases. This information is obtained with the `getMetaData` method.

Note: By default a `Connection` object is in auto-commit mode, which means that it automatically commits changes after executing each statement. If auto-commit mode has been disabled, the method `commit` must be called explicitly in order to commit changes; otherwise, database changes will not be saved.

See Also:
  `DriverManager.getConnection(java.lang.String, java.util.Properties)`, `Statement`, `UnityStatement`, `ResultSet`, `UnityResultSet`, `DatabaseMetaData`, `UnityDatabaseMetaData`

Constructor Summary
`UnityConnection(GlobalSchema gs, java.util.Properties info)`

Method Summary
`void` | `clearWarnings()` Clears all warnings reported for this `Connection` object.
`void` | `close()` Releases this `Connection` object's database and JDBC resources immediately instead of waiting for them to be automatically released.
`void` | `commit()` Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by this `Connection` object.
`java.sql.Statement` | `createStatement()`
`java.sql.Statement` | `createStatement(int resultSetType, int resultSetConcurrency)` Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency.
`java.sql.Statement` | `createStatement(int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.
`boolean` | `getAutoCommit()` Retrieves the current auto-commit mode for this `Connection` object.
`java.lang.String` | `getCatalog()` Retrieves this `Connection` object's current catalog name.
`java.util.ArrayList` | `getDatabases()`
`int` | `getHoldability()` Retrieves the current holdability of `ResultSet` objects created using this `Connection` object.
`java.sql.DatabaseMetaData` | `getMetaData()` Retrieves a `DatabaseMetaData` object that contains metadata about the database to which this `Connection` object represents a connection.
`int` | `getTransactionIsolation()` Retrieves this `Connection` object's current transaction isolation level.
`java.util.Map` | `getTypeMap()` Retrieves the `Map` object associated with this `Connection` object.
`java.sql.SQLWarning` | `getWarnings()` Retrieves the first warning reported by calls on this `Connection` object.
`boolean` | `isClosed()` Retrieves whether this `Connection` object has been closed.
`boolean` | `isReadOnly()` Retrieves whether this `Connection` object is in read-only mode.
`java.lang.String` | `nativeSQL(java.lang.String sql)` Converts the given SQL statement into the system's native SQL grammar.
`java.sql.CallableStatement` | `prepareCall(java.lang.String sql)` Creates a `CallableStatement` object for calling database stored procedures.
`java.sql.CallableStatement` | `prepareCall(java.lang.String sql, int resultSetType, int resultSetConcurrency)` Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`java.sql.CallableStatement` | `prepareCall(java.lang.String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql)` Creates a `PreparedStatement` object for sending parameterized SQL statements to the database.
`java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, int autoGeneratedKeys)` Creates a default `PreparedStatement` object that has the capability to retrieve auto-generated keys.
`java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, int[] columnIndexes)` Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array.
`java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, int resultSetType, int resultSetConcurrency)` Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.
`java.sql.PreparedStatement` | `prepareStatement(java.lang.String sql, java.lang.String[] columnNames)` Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array.
`void` | `releaseSavepoint(java.sql.Savepoint savepoint)` Removes the given `Savepoint` object from the current transaction.
`void` | `rollback()` Undoes all changes made in the current transaction and releases any database locks currently held by this `Connection` object.
`void` | `rollback(java.sql.Savepoint savepoint)` Undoes all changes made after the given `Savepoint` object was set.
`void` | `setAutoCommit(boolean autoCommit)` Sets this connection's auto-commit mode to the given state.
`void` | `setCatalog(java.lang.String catalog)` Sets the given catalog name in order to select a subspace of this `Connection` object's database in which to work.
`void` | `setHoldability(int holdability)` Changes the holdability of `ResultSet` objects created using this `Connection` object to the given holdability.
`void` | `setReadOnly(boolean readOnly)` Puts this connection in read-only mode as a hint to the driver to enable database optimizations.
`java.sql.Savepoint` | `setSavepoint()` Creates an unnamed savepoint in the current transaction and returns the new `Savepoint` object that represents it.
`java.sql.Savepoint` | `setSavepoint(java.lang.String name)` Creates a savepoint with the given name in the current transaction and returns the new `Savepoint` object that represents it.
`void` | `setTransactionIsolation(int level)` Attempts to change the transaction isolation level for this `Connection` object to the one given.
`void` | `setTypeMap(java.util.Map map)` Installs the given `TypeMap` object as the type map for this `Connection` object.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### UnityConnection

    public UnityConnection(GlobalSchema gs,
                           java.util.Properties info)

Method Detail

### createStatement

    public java.sql.Statement createStatement()
                                       throws java.sql.SQLException

  Specified by:
    `createStatement` in interface `java.sql.Connection`
  Throws:
    `java.sql.SQLException`

### createStatement

    public java.sql.Statement createStatement(int resultSetType,
                                              int resultSetConcurrency)
                                       throws java.sql.SQLException

  Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `createStatement` method above, but it allows the default result set type and concurrency to be overridden.

  Specified by:
    `createStatement` in interface `java.sql.Connection`
  Parameters:
    `resultSetType` - a result set type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE` (not supported)
    `resultSetConcurrency` - a concurrency type; one of `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  Returns:
    a new `Statement` object that will generate `ResultSet` objects with the given type and concurrency
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given parameters are not `ResultSet` constants indicating type and concurrency
  Since:
    1.2

### prepareStatement

    public java.sql.PreparedStatement prepareStatement(java.lang.String sql)
                                                throws java.sql.SQLException

  Creates a `PreparedStatement` object for sending parameterized SQL statements to the database.

  A SQL statement with or without IN parameters can be pre-compiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

  Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain `SQLException` objects.

  Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY`.

  Specified by:
    `prepareStatement` in interface `java.sql.Connection`
  Parameters:
    `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
  Returns:
    a new default `PreparedStatement` object containing the pre-compiled SQL statement
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### prepareCall

    public java.sql.CallableStatement prepareCall(java.lang.String sql)
                                           throws java.sql.SQLException

  Creates a `CallableStatement` object for calling database stored procedures. The `CallableStatement` object provides methods for setting up its IN and OUT parameters, and methods for executing the call to a stored procedure.

  Note: This method is optimized for handling stored procedure call statements. Some drivers may send the call statement to the database when the method `prepareCall` is done; others may wait until the `CallableStatement` object is executed. This has no direct effect on users; however, it does affect which method throws certain SQLExceptions.

  Result sets created using the returned `CallableStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY`.

  Specified by:
    `prepareCall` in interface `java.sql.Connection`
  Parameters:
    `sql` - an SQL statement that may contain one or more '?' parameter placeholders. Typically this statement is a JDBC function call escape string.
  Returns:
    a new default `CallableStatement` object containing the pre-compiled SQL statement
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### nativeSQL

    public java.lang.String nativeSQL(java.lang.String sql)
                               throws java.sql.SQLException

  Converts the given SQL statement into the system's native SQL grammar. A driver may convert the JDBC SQL grammar into its system's native SQL grammar prior to sending it. This method returns the native form of the statement that the driver would have sent.

  Specified by:
    `nativeSQL` in interface `java.sql.Connection`
  Parameters:
    `sql` - an SQL statement that may contain one or more '?' parameter placeholders
  Returns:
    the native form of this statement
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setAutoCommit

    public void setAutoCommit(boolean autoCommit)
                       throws java.sql.SQLException

  Sets this connection's auto-commit mode to the given state. If a connection is in auto-commit mode, then all its SQL statements will be executed and committed as individual transactions. Otherwise, its SQL statements are grouped into transactions that are terminated by a call to either the method `commit` or the method `rollback`. By default, new connections are in auto-commit mode.

  The commit occurs when the statement completes or the next execute occurs, whichever comes first. In the case of statements returning a `ResultSet` object, the statement completes when the last row of the `ResultSet` object has been retrieved or the `ResultSet` object has been closed. In advanced cases, a single statement may return multiple results as well as output parameter values. In these cases, the commit occurs when all results and output parameter values have been retrieved.

  NOTE: If this method is called during a transaction, the transaction is committed.

  Specified by:
    `setAutoCommit` in interface `java.sql.Connection`
  Parameters:
    `autoCommit` - `true` to enable auto-commit mode; `false` to disable it
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getAutoCommit()`

### getAutoCommit

    public boolean getAutoCommit()
                          throws java.sql.SQLException

  Retrieves the current auto-commit mode for this `Connection` object.

  Specified by:
    `getAutoCommit` in interface `java.sql.Connection`
  Returns:
    the current state of this `Connection` object's auto-commit mode
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `setAutoCommit(boolean)`

### commit

    public void commit()
                throws java.sql.SQLException

  Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by this `Connection` object. This method should be used only when auto-commit mode has been disabled.

  Specified by:
    `commit` in interface `java.sql.Connection`
  Throws:
    `java.sql.SQLException` - if a database access error occurs or this `Connection` object is in auto-commit mode
  See Also:
    `setAutoCommit(boolean)`

### rollback

    public void rollback()
                  throws java.sql.SQLException

  Undoes all changes made in the current transaction and releases any database locks currently held by this `Connection` object. This method should be used only when auto-commit mode has been disabled.

  Specified by:
    `rollback` in interface `java.sql.Connection`
  Throws:
    `java.sql.SQLException` - if a database access error occurs or this `Connection` object is in auto-commit mode
  See Also:
    `setAutoCommit(boolean)`

### close

    public void close()
               throws java.sql.SQLException

  Releases this `Connection` object's database and JDBC resources immediately instead of waiting for them to be automatically released.

  Calling the method `close` on a `Connection` object that is already closed is a no-op.

  Note: A `Connection` object is automatically closed when it is garbage collected. Certain fatal errors also close a `Connection` object.

  Specified by:
    `close` in interface `java.sql.Connection`
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### isClosed

    public boolean isClosed()
                     throws java.sql.SQLException

  Retrieves whether this `Connection` object has been closed. A connection is closed if the method `close` has been called on it or if certain fatal errors have occurred. This method is guaranteed to return `true` only when it is called after the method `Connection.close` has been called.

  This method generally cannot be called to determine whether a connection to a database is valid or invalid. A typical client can determine that a connection is invalid by catching any exceptions that might be thrown when an operation is attempted.

  Specified by:
    `isClosed` in interface `java.sql.Connection`
  Returns:
    `true` if this `Connection` object is closed; `false` if it is still open
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getMetaData

    public java.sql.DatabaseMetaData getMetaData()
                                          throws java.sql.SQLException

  Retrieves a `DatabaseMetaData` object that contains metadata about the database to which this `Connection` object represents a connection. The metadata includes information about the database's tables, its supported SQL grammar, its stored procedures, the capabilities of this connection, and so on.

  Specified by:
    `getMetaData` in interface `java.sql.Connection`
  Returns:
    a `DatabaseMetaData` object for this `Connection` object
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setReadOnly

    public void setReadOnly(boolean readOnly)
                     throws java.sql.SQLException

  Puts this connection in read-only mode as a hint to the driver to enable database optimizations.

  Note: This method cannot be called during a transaction.

  Specified by:
    `setReadOnly` in interface `java.sql.Connection`
  Parameters:
    `readOnly` - `true` enables read-only mode; `false` disables it
  Throws:
    `java.sql.SQLException` - if a database access error occurs or this method is called during a transaction

### isReadOnly

    public boolean isReadOnly()
                       throws java.sql.SQLException

  Retrieves whether this `Connection` object is in read-only mode.

  Specified by:
    `isReadOnly` in interface `java.sql.Connection`
  Returns:
    `true` if this `Connection` object is read-only; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setCatalog

    public void setCatalog(java.lang.String catalog)
                    throws java.sql.SQLException

  Sets the given catalog name in order to select a subspace of this `Connection` object's database in which to work.

  If the driver does not support catalogs, it will silently ignore this request.

  Specified by:
    `setCatalog` in interface `java.sql.Connection`
  Parameters:
    `catalog` - the name of a catalog (subspace in this `Connection` object's database) in which to work
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `getCatalog()`

### getCatalog

    public java.lang.String getCatalog()
                                throws java.sql.SQLException

  Retrieves this `Connection` object's current catalog name.

  Specified by:
    `getCatalog` in interface `java.sql.Connection`
  Returns:
    the current catalog name or `null` if there is none
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `setCatalog(java.lang.String)`

### setTransactionIsolation

    public void setTransactionIsolation(int level)
                                 throws java.sql.SQLException

  Attempts to change the transaction isolation level for this `Connection` object to the one given. The constants defined in the interface `Connection` are the possible transaction isolation levels.

  Note: If this method is called during a transaction, the result is implementation-defined.

  Specified by:
    `setTransactionIsolation` in interface `java.sql.Connection`
  Parameters:
    `level` - one of the following `Connection` constants: `Connection.TRANSACTION_READ_UNCOMMITTED`, `Connection.TRANSACTION_READ_COMMITTED`, `Connection.TRANSACTION_REPEATABLE_READ`, or `Connection.TRANSACTION_SERIALIZABLE`. (Note that `Connection.TRANSACTION_NONE` cannot be used because it specifies that transactions are not supported.)
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given parameter is not one of the `Connection` constants
  See Also:
    `DatabaseMetaData.supportsTransactionIsolationLevel(int)`, `getTransactionIsolation()`

### getTransactionIsolation

    public int getTransactionIsolation()
                                throws java.sql.SQLException

  Retrieves this `Connection` object's current transaction isolation level.

  Specified by:
    `getTransactionIsolation` in interface `java.sql.Connection`
  Returns:
    the current transaction isolation level, which will be one of the following constants: `Connection.TRANSACTION_READ_UNCOMMITTED`, `Connection.TRANSACTION_READ_COMMITTED`, `Connection.TRANSACTION_REPEATABLE_READ`, `Connection.TRANSACTION_SERIALIZABLE`, or `Connection.TRANSACTION_NONE`.
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `setTransactionIsolation(int)`

### getWarnings

    public java.sql.SQLWarning getWarnings()
                                    throws java.sql.SQLException

  Retrieves the first warning reported by calls on this `Connection` object. If there is more than one warning, subsequent warnings will be chained to the first one and can be retrieved by calling the method `SQLWarning.getNextWarning` on the warning that was retrieved previously.

  This method may not be called on a closed connection; doing so will cause an `SQLException` to be thrown.

  Note: Subsequent warnings will be chained to this SQLWarning.

  Specified by:
    `getWarnings` in interface `java.sql.Connection`
  Returns:
    the first `SQLWarning` object or `null` if there are none
  Throws:
    `java.sql.SQLException` - if a database access error occurs or this method is called on a closed connection
  See Also:
    `SQLWarning`

### clearWarnings

    public void clearWarnings()
                       throws java.sql.SQLException

  Clears all warnings reported for this `Connection` object. After a call to this method, the method `getWarnings` returns `null` until a new warning is reported for this `Connection` object.

  Specified by:
    `clearWarnings` in interface `java.sql.Connection`
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### prepareStatement

    public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                       int resultSetType,
                                                       int resultSetConcurrency)
                                                throws java.sql.SQLException

  Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareStatement` method above, but it allows the default result set type and concurrency to be overridden.

  Specified by:
    `prepareStatement` in interface `java.sql.Connection`
  Parameters:
    `sql` - a `String` object that is the SQL statement to be sent to the database; may contain one or more ? IN parameters
    `resultSetType` - a result set type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
    `resultSetConcurrency` - a concurrency type; one of `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  Returns:
    a new PreparedStatement object containing the pre-compiled SQL statement that will produce `ResultSet` objects with the given type and concurrency
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given parameters are not `ResultSet` constants indicating type and concurrency
  Since:
    1.2

### prepareCall

    public java.sql.CallableStatement prepareCall(java.lang.String sql,
                                                  int resultSetType,
                                                  int resultSetConcurrency)
                                           throws java.sql.SQLException

  Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareCall` method above, but it allows the default result set type and concurrency to be overridden.

  Specified by:
    `prepareCall` in interface `java.sql.Connection`
  Parameters:
    `sql` - a `String` object that is the SQL statement to be sent to the database; may contain on or more ? parameters
    `resultSetType` - a result set type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
    `resultSetConcurrency` - a concurrency type; one of `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  Returns:
    a new `CallableStatement` object containing the pre-compiled SQL statement that will produce `ResultSet` objects with the given type and concurrency
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given parameters are not `ResultSet` constants indicating type and concurrency
  Since:
    1.2

### getTypeMap

    public java.util.Map getTypeMap()
                             throws java.sql.SQLException

  Retrieves the `Map` object associated with this `Connection` object. Unless the application has added an entry, the type map returned will be empty.

  Specified by:
    `getTypeMap` in interface `java.sql.Connection`
  Returns:
    the `java.util.Map` object associated with this `Connection` object
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    `setTypeMap(java.util.Map)`

### setTypeMap

    public void setTypeMap(java.util.Map map)
                    throws java.sql.SQLException

  Installs the given `TypeMap` object as the type map for this `Connection` object. The type map will be used for the custom mapping of SQL structured types and distinct types.

  Specified by:
    `setTypeMap` in interface `java.sql.Connection`
  Parameters:
    `map` - the `java.util.Map` object to install as the replacement for this `Connection` object's default type map
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given parameter is not a `java.util.Map` object
  Since:
    1.2
  See Also:
    `getTypeMap()`

### setHoldability

    public void setHoldability(int holdability)
                        throws java.sql.SQLException

  Changes the holdability of `ResultSet` objects created using this `Connection` object to the given holdability.

  Specified by:
    `setHoldability` in interface `java.sql.Connection`
  Parameters:
    `holdability` - a `ResultSet` holdability constant; one of `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Throws:
    `java.sql.SQLException` - if a database access occurs, the given parameter is not a `ResultSet` constant indicating holdability, or the given holdability is not supported
  Since:
    1.4
  See Also:
    `getHoldability()`, `ResultSet`

### getHoldability

    public int getHoldability()
                       throws java.sql.SQLException

  Retrieves the current holdability of `ResultSet` objects created using this `Connection` object.

  Specified by:
    `getHoldability` in interface `java.sql.Connection`
  Returns:
    the holdability, one of `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Throws:
    `java.sql.SQLException` - if a database access occurs
  Since:
    1.4
  See Also:
    `setHoldability(int)`, `ResultSet`

### setSavepoint

    public java.sql.Savepoint setSavepoint()
                                    throws java.sql.SQLException

  Creates an unnamed savepoint in the current transaction and returns the new `Savepoint` object that represents it.

  Specified by:
    `setSavepoint` in interface `java.sql.Connection`
  Returns:
    the new `Savepoint` object
  Throws:
    `java.sql.SQLException` - if a database access error occurs or this `Connection` object is currently in auto-commit mode
  Since:
    1.4
  See Also:
    `Savepoint`

### setSavepoint

    public java.sql.Savepoint setSavepoint(java.lang.String name)
                                    throws java.sql.SQLException

  Creates a savepoint with the given name in the current transaction and returns the new `Savepoint` object that represents it.

  Specified by:
    `setSavepoint` in interface `java.sql.Connection`
  Parameters:
    `name` - a `String` containing the name of the savepoint
  Returns:
    the new `Savepoint` object
  Throws:
    `java.sql.SQLException` - if a database access error occurs or this `Connection` object is currently in auto-commit mode
  Since:
    1.4
  See Also:
    `Savepoint`

### rollback

    public void rollback(java.sql.Savepoint savepoint)
                  throws java.sql.SQLException

  Undoes all changes made after the given `Savepoint` object was set.

  This method should be used only when auto-commit has been disabled.

  Specified by:
    `rollback` in interface `java.sql.Connection`
  Parameters:
    `savepoint` - the `Savepoint` object to roll back to
  Throws:
    `java.sql.SQLException` - if a database access error occurs, the `Savepoint` object is no longer valid, or this `Connection` object is currently in auto-commit mode
  Since:
    1.4
  See Also:
    `Savepoint`, `rollback()`

### releaseSavepoint

    public void releaseSavepoint(java.sql.Savepoint savepoint)
                          throws java.sql.SQLException

  Removes the given `Savepoint` object from the current transaction. Any reference to the savepoint after it have been removed will cause an `SQLException` to be thrown.

  Specified by:
    `releaseSavepoint` in interface `java.sql.Connection`
  Parameters:
    `savepoint` - the `Savepoint` object to be removed
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given `Savepoint` object is not a valid savepoint in the current transaction
  Since:
    1.4

### createStatement

    public java.sql.Statement createStatement(int resultSetType,
                                              int resultSetConcurrency,
                                              int resultSetHoldability)
                                       throws java.sql.SQLException

  Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability. This method is the same as the `createStatement` method above, but it allows the default result set type, concurrency, and holdability to be overridden.

  Specified by:
    `createStatement` in interface `java.sql.Connection`
  Parameters:
    `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
    `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
    `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Returns:
    a new `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
  Since:
    1.4
  See Also:
    `ResultSet`

### prepareStatement

    public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                       int resultSetType,
                                                       int resultSetConcurrency,
                                                       int resultSetHoldability)
                                                throws java.sql.SQLException

  Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.

  This method is the same as the `prepareStatement` method above, but it allows the default result set type, concurrency, and holdability to be overridden.

  Specified by:
    `prepareStatement` in interface `java.sql.Connection`
  Parameters:
    `sql` - a `String` object that is the SQL statement to be sent to the database; may contain one or more ? IN parameters
    `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
    `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
    `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Returns:
    a new `PreparedStatement` object, containing the pre-compiled SQL statement, that will generate `ResultSet` objects with the given type, concurrency, and holdability
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
  Since:
    1.4
  See Also:
    `ResultSet`

### prepareCall

    public java.sql.CallableStatement prepareCall(java.lang.String sql,
                                                  int resultSetType,
                                                  int resultSetConcurrency,
                                                  int resultSetHoldability)
                                           throws java.sql.SQLException

  Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareCall` method above, but it allows the default result set type, result set concurrency type and holdability to be overridden.

  Specified by:
    `prepareCall` in interface `java.sql.Connection`
  Parameters:
    `sql` - a `String` object that is the SQL statement to be sent to the database; may contain on or more ? parameters
    `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
    `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
    `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Returns:
    a new `CallableStatement` object, containing the pre-compiled SQL statement, that will generate `ResultSet` objects with the given type, concurrency, and holdability
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
  Since:
    1.4
  See Also:
    `ResultSet`

### prepareStatement

    public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                       int autoGeneratedKeys)
                                                throws java.sql.SQLException

  Creates a default `PreparedStatement` object that has the capability to retrieve auto-generated keys. The given constant tells the driver whether it should make auto-generated keys available for retrieval. This parameter is ignored if the SQL statement is not an `INSERT` statement.

  Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain SQLExceptions.

  Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY`.

  Specified by:
    `prepareStatement` in interface `java.sql.Connection`
  Parameters:
    `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
    `autoGeneratedKeys` - a flag indicating that auto-generated keys should be returned, one of `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`.
  Returns:
    a new `PreparedStatement` object, containing the pre-compiled SQL statement, that will have the capability of returning auto-generated keys
  Throws:
    `java.sql.SQLException` - if a database access error occurs or the given parameter is not a `Statement` constant indicating whether auto-generated keys should be returned
  Since:
    1.4

### prepareStatement

    public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                       int[] columnIndexes)
                                                throws java.sql.SQLException

  Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. This array is ignored if the SQL statement is not an `INSERT` statement.

  An SQL statement with or without IN parameters can be pre-compiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

  Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain SQLExceptions.

  Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY`.

  Specified by:
    `prepareStatement` in interface `java.sql.Connection`
  Parameters:
    `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
    `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row or rows
  Returns:
    a new `PreparedStatement` object, containing the pre-compiled statement, that is capable of returning the auto-generated keys designated by the given array of column indexes
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    1.4

### prepareStatement

    public java.sql.PreparedStatement prepareStatement(java.lang.String sql,
                                                       java.lang.String[] columnNames)
                                                throws java.sql.SQLException

  Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array. This array contains the names of the columns in the target table that contain the auto-generated keys that should be returned. This array is ignored if the SQL statement is not an `INSERT` statement.

  An SQL statement with or without IN parameters can be pre-compiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

  Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain SQLExceptions.

  Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY`.

  Specified by:
    `prepareStatement` in interface `java.sql.Connection`
  Parameters:
    `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
    `columnNames` - an array of column names indicating the columns that should be returned from the inserted row or rows
  Returns:
    a new `PreparedStatement` object, containing the pre-compiled statement, that is capable of returning the auto-generated keys designated by the given array of column names
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  Since:
    1.4

### getDatabases

    public java.util.ArrayList getDatabases()

  Returns:
    An ArrayList containing annotated databases from the GlobalSchema
  See Also:
    `GlobalSchema`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD